SystemOrganization addCategory: #KoCizen!
SystemOrganization addCategory: #'KoCizen-Tests'!

TestCase subclass: #ARBibCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen-Tests'!

!CZDisplayPattern methodsFor: '*kocizen' stamp: ''!
filteredEntry

	CZEntry new
		fields! !

!CZDisplayPattern methodsFor: '*kocizen' stamp: ''!
filteredEntry: anEntry
	
	| cpy |
	cpy := anEntry copy.
	anEntry
	 
		! !

CZVisitor subclass: #KZBibCollectionBuilder
	instanceVariableNames: 'dispatchTag bibset author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!KZBibCollectionBuilder commentStamp: 'StephaneDucasse 3/14/2012 21:48' prior: 0!
A builder to create collection of CZEntries wrapped into a Kozen structure. !

!KZBibCollectionBuilder methodsFor: 'accessing' stamp: 'StephaneDucasse 3/14/2012 21:46'!
author

	^ author ifNil: [ author := '*Ducasse*']! !

!KZBibCollectionBuilder methodsFor: 'accessing' stamp: 'StephaneDucasse 3/14/2012 21:46'!
author: aString
	"author argument should be in the form: '*Ducasse*' for example."
	 author := aString! !

!KZBibCollectionBuilder methodsFor: 'public' stamp: ''!
collectionBasedOnKozenTag: aTag
	"Return a KZ collection holding CZEntries having a given tag"
	
	^ KZBibCollection new elements: (self filterKozenTag: aTag); yourself
	

! !

!KZBibCollectionBuilder methodsFor: 'private' stamp: ''!
filter: aQuery
	
	^ (bibset entries select: [ :each | aQuery value: each])! !

!KZBibCollectionBuilder methodsFor: 'private' stamp: ''!
filterKozenTag: aTag

	^ self filter:  (self queryForKozenTag: aTag).! !

!KZBibCollectionBuilder methodsFor: 'file' stamp: 'StephaneDucasse 3/14/2012 21:37'!
initializeBibSetFromPath: inputFile
	"self new createBibSetFromPath: 'rmod.bib'"
	
	bibset  := CZFileLoader bibFromFileNamed: inputFile.! !

!KZBibCollectionBuilder methodsFor: 'file' stamp: ''!
loadBib: aString

	self initializeBibSetFromPath: aString.
	self prepareForAuthor.
	! !

!KZBibCollectionBuilder methodsFor: 'accessing' stamp: 'StephaneDucasse 3/14/2012 21:45'!
originalBibSet: aCZSet 
	
	bibset := aCZSet.
	self prepareForAuthor.! !

!KZBibCollectionBuilder methodsFor: 'private' stamp: 'StephaneDucasse 3/14/2012 21:44'!
prepareForAuthor
	
	bibset entries: (bibset entries select: self queryWithAuthor).
	bibset entries: (bibset entries reject:  (CZFieldQuery 
												named: #keywords 
												checks: [ :value | '*insubmission*' match: value ])).
	! !

!KZBibCollectionBuilder methodsFor: 'queries' stamp: ''!
queryForKozenTag: aTag

	^ CZFieldQuery named: #keywords checks: [ :value | aTag match: value ]! !

!KZBibCollectionBuilder methodsFor: 'queries' stamp: ''!
queryWithAuthor
	^ CZFieldQuery named: #author checks: [ :value | self author match: value ]! !

KZList subclass: #KZBibCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!KZBibCollection commentStamp: 'sd 1/8/2012 17:21' prior: 0!
I'm a wrapper so that I can be put in a site structure but holding items of citezen.
during my visit the visitor can decide to invoke a citezen exporter. 

Not clear at the design level yet.!

!KZBibCollection methodsFor: 'as yet unclassified' stamp: ''!
accept: aVisitor

	aVisitor visitBibItemCollection: self! !

!KZBibCollection methodsFor: 'as yet unclassified' stamp: ''!
elements: aCol

	elements := aCol! !
